% lab20_ex_rcos_RDS.m
% Pulse shaping filter (PSF) used for RDS symbols in the FM radio standard

fs = 228000;               % sampling frequency of one FM radio station
fsymb = 19000/16;          % symbol rate in the RDS data system
Ks = 8;                    % number of symbols in the PSF filter
Tsymb = 1/fsymb;           % time duration of one RDS symbol   
Nsymb = round(fs/fsymb);   % number of samples per one RDS symbol
Npsf = Ks*Nsymb;           % number of samples of the PSF filter
if(rem(Npsf,2)==1) Npsf=Npsf+1; end
df = fs/Npsf; f = 0 : df : 2/Tsymb; Nf=length(f);          % spectrum 
H = zeros(1, Npsf); H(1:Nf) = cos(pi*f*Tsymb/4); H(end:-1:end-(Nf-2)) = H(2:Nf);
hpsf1 = fftshift(ifft(H)); hpsf1=hpsf1/max(hpsf1);         % imp. response #1
hpsf2 = firrcos( Npsf, fsymb, 0.9999, fs,'rollof','sqrt'); % imp. response #2
hpsf2 = hpsf2/max(hpsf2); hpsf2 = hpsf2(1:end-1);
n1=1:length(hpsf1); n2=1:length(hpsf2);
figure; plot(n1,hpsf1,'ro-',n2,hpsf2,'bx-');
xlabel('n'); title('hpsf1(n)  and  hpsf2(n)'); grid;