function [ synch, Nsynch ] = modtype2header( modtype )
% Generation of synchronization headers for different modulations 

switch modtype
case {'2PAM','BPSK' }
   synch = [ 1 1 1 0 0 0 1 0 0 1 1 0 1 0 1 1 1 0 0 0 1 0 0 1 1 0 1 0 1 1 ...
             1 1 0 0 0 1 0 0 1 1 0 1 0 1 ]; % pseudo random binary sequence 
 % synch = [ 0 1 0 0 0 0 0 0 0 1 1 1 0 0 0 0 0 1 0 0 1 1 1 0 1 1 0 0 0 1 1 0 ]; % Gold #1, 32
 % synch = [ 0 0 0 0 0 0 1 0 0 0 1 1 0 1 1 0 0 0 0 1 1 0 0 1 1 1 0 0 1 1 ];     % Gold #2, 30
 % synch = [ 1 0 0 0 1 1 1 1 1 1 1 0 0 0 1 0 0 0 1 1 1 1 0 0 0 1 0 1 0 0 ];     % Gold #3, 30
 % synch = [ 1 1 1 1 1 0 0 1 1 0 1 0 1 ]; synch = [ synch synch synch ]         % 3x Barker13 	 
case {'4PAM','QPSK','DQPSK','4QAM'}
 % synch = [ 3 0 0 1 2 1 3 0 3 2 2 1 3 0 0 1 2 1 3 ]; synch = [ synch synch(end:-1:1) ]; % STS Tetra 19
   synch = [ 0 3 0 0 0 0 0 0 0 3 3 3 0 0 0 0 0 3 0 0 3 3 3 0 3 3 0 0 0 3 3 0 ]; % Gold #1, 32
 % synch = [ 3 3 3 0 0 0 3 0 0 3 3 0 3 0 3 3 3 0 0 0 3 0 0 3 3 0 3 0 3 3 ...
 %           3 3 0 0 0 3 0 0 3 3 0 3 0 3 ]; % pseudo random binary sequence
 % Nsynch=99; synch = floor( Nstates*(rand(1,Nsynch) - 10*eps) );
case {'8PAM','8PSK'}  
   synch = [ 1, 5, 1, 3, 6, 1, 3, 1, 1, 6, 3, 7, 7, 3, 5, 4, 3, 6, 6, 4, 5, 4, 0, ...
             2, 2, 2, 6, 0, 7, 5, 7, 4, 0, 7, 5, 7, 1, 6, 1, 0, 5, 2, 2, 6, 2, 3, ...
             6, 0, 0, 5, 1, 4, 2, 2, 2, 3, 4, 0, 6, 2, 7, 4, 3, 3, 7, 2, 0, 2, 6, ...
             4, 4, 1, 7, 6, 2, 0, 6, 2, 3, 6, 7, 4, 3, 6, 1, 3, 7, 4, 6, 5, 7, 2, ...
             0, 1, 1, 1, 4, 4, 0, 0, 5, 7, 7, 4, 7, 3, 5, 4, 1, 6, 5, 6, 6, 4, 6, ...
             3, 4, 3, 0, 7, 1, 3, 4, 7, 0, 1, 4, 3, 3, 3, 5, 1, 1, 1, 4, 6, 1, 0, ...
             6, 0, 1, 3, 1, 4, 1, 7, 7, 6, 3, 0, 0, 7, 2, 7, 2, 0, 2, 6, 1, 1, 1, ...
             2, 7, 7, 5, 3, 3, 6, 0, 5, 3, 3, 1, 0, 7, 1, 1, 0, 3, 0, 4, 0, 7, 3 ];
 case{'16QAM'}
   synch = [ 8 8 8 2 2 2 8 2 2 8 8 2 8 2 8 8 8 2 2 2 8 2 2 8 8 2 8 2 8 8 ... 
             8 8 2 2 2 8 2 2 8 8 2 8 2 8 ]; % pseudo random binary sequence 
otherwise disp('Unknown modulation type'); 
   Nsynch=99; synch = floor( Nstates*(rand(1,Nsynch) - 10*eps) );
end   
synch = synch'; Nsynch=length(synch); 
